package com.hai.dao;

import com.hai.entity.HighRefundAudit;
import com.hai.entity.HighRefundAuditExample.Criteria;
import com.hai.entity.HighRefundAuditExample.Criterion;
import com.hai.entity.HighRefundAuditExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighRefundAuditSqlProvider {

    public String countByExample(HighRefundAuditExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_refund_audit");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighRefundAuditExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_refund_audit");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighRefundAudit record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_refund_audit");
        
        if (record.getRefundSource() != null) {
            sql.VALUES("refund_source", "#{refundSource,jdbcType=INTEGER}");
        }
        
        if (record.getRefundPrice() != null) {
            sql.VALUES("refund_price", "#{refundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayType() != null) {
            sql.VALUES("pay_type", "#{payType,jdbcType=INTEGER}");
        }
        
        if (record.getSourceOrderNo() != null) {
            sql.VALUES("source_order_no", "#{sourceOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayTime() != null) {
            sql.VALUES("pay_time", "#{payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreatedUserId() != null) {
            sql.VALUES("created_user_id", "#{createdUserId,jdbcType=INTEGER}");
        }
        
        if (record.getCreatedTime() != null) {
            sql.VALUES("created_time", "#{createdTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreatedUserName() != null) {
            sql.VALUES("created_user_name", "#{createdUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getUpdatedUserId() != null) {
            sql.VALUES("updated_user_id", "#{updatedUserId,jdbcType=INTEGER}");
        }
        
        if (record.getUpdatedUserName() != null) {
            sql.VALUES("updated_user_name", "#{updatedUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getUpdatedTime() != null) {
            sql.VALUES("updated_time", "#{updatedTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRemark() != null) {
            sql.VALUES("remark", "#{remark,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCompanId() != null) {
            sql.VALUES("compan_id", "#{companId,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighRefundAuditExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("refund_source");
        sql.SELECT("refund_price");
        sql.SELECT("pay_type");
        sql.SELECT("source_order_no");
        sql.SELECT("pay_time");
        sql.SELECT("created_user_id");
        sql.SELECT("created_time");
        sql.SELECT("created_user_name");
        sql.SELECT("updated_user_id");
        sql.SELECT("updated_user_name");
        sql.SELECT("updated_time");
        sql.SELECT("remark");
        sql.SELECT("`status`");
        sql.SELECT("compan_id");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_refund_audit");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighRefundAudit record = (HighRefundAudit) parameter.get("record");
        HighRefundAuditExample example = (HighRefundAuditExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_refund_audit");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=INTEGER}");
        }
        
        if (record.getRefundSource() != null) {
            sql.SET("refund_source = #{record.refundSource,jdbcType=INTEGER}");
        }
        
        if (record.getRefundPrice() != null) {
            sql.SET("refund_price = #{record.refundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        }
        
        if (record.getSourceOrderNo() != null) {
            sql.SET("source_order_no = #{record.sourceOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayTime() != null) {
            sql.SET("pay_time = #{record.payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreatedUserId() != null) {
            sql.SET("created_user_id = #{record.createdUserId,jdbcType=INTEGER}");
        }
        
        if (record.getCreatedTime() != null) {
            sql.SET("created_time = #{record.createdTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreatedUserName() != null) {
            sql.SET("created_user_name = #{record.createdUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getUpdatedUserId() != null) {
            sql.SET("updated_user_id = #{record.updatedUserId,jdbcType=INTEGER}");
        }
        
        if (record.getUpdatedUserName() != null) {
            sql.SET("updated_user_name = #{record.updatedUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getUpdatedTime() != null) {
            sql.SET("updated_time = #{record.updatedTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRemark() != null) {
            sql.SET("remark = #{record.remark,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCompanId() != null) {
            sql.SET("compan_id = #{record.companId,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_refund_audit");
        
        sql.SET("id = #{record.id,jdbcType=INTEGER}");
        sql.SET("refund_source = #{record.refundSource,jdbcType=INTEGER}");
        sql.SET("refund_price = #{record.refundPrice,jdbcType=DECIMAL}");
        sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        sql.SET("source_order_no = #{record.sourceOrderNo,jdbcType=VARCHAR}");
        sql.SET("pay_time = #{record.payTime,jdbcType=TIMESTAMP}");
        sql.SET("created_user_id = #{record.createdUserId,jdbcType=INTEGER}");
        sql.SET("created_time = #{record.createdTime,jdbcType=TIMESTAMP}");
        sql.SET("created_user_name = #{record.createdUserName,jdbcType=VARCHAR}");
        sql.SET("updated_user_id = #{record.updatedUserId,jdbcType=INTEGER}");
        sql.SET("updated_user_name = #{record.updatedUserName,jdbcType=VARCHAR}");
        sql.SET("updated_time = #{record.updatedTime,jdbcType=TIMESTAMP}");
        sql.SET("remark = #{record.remark,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("compan_id = #{record.companId,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighRefundAuditExample example = (HighRefundAuditExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighRefundAudit record) {
        SQL sql = new SQL();
        sql.UPDATE("high_refund_audit");
        
        if (record.getRefundSource() != null) {
            sql.SET("refund_source = #{refundSource,jdbcType=INTEGER}");
        }
        
        if (record.getRefundPrice() != null) {
            sql.SET("refund_price = #{refundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{payType,jdbcType=INTEGER}");
        }
        
        if (record.getSourceOrderNo() != null) {
            sql.SET("source_order_no = #{sourceOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayTime() != null) {
            sql.SET("pay_time = #{payTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreatedUserId() != null) {
            sql.SET("created_user_id = #{createdUserId,jdbcType=INTEGER}");
        }
        
        if (record.getCreatedTime() != null) {
            sql.SET("created_time = #{createdTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreatedUserName() != null) {
            sql.SET("created_user_name = #{createdUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getUpdatedUserId() != null) {
            sql.SET("updated_user_id = #{updatedUserId,jdbcType=INTEGER}");
        }
        
        if (record.getUpdatedUserName() != null) {
            sql.SET("updated_user_name = #{updatedUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getUpdatedTime() != null) {
            sql.SET("updated_time = #{updatedTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRemark() != null) {
            sql.SET("remark = #{remark,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCompanId() != null) {
            sql.SET("compan_id = #{companId,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=INTEGER}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighRefundAuditExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}