package com.hai.service;

import com.hai.entity.HighDiscountPackageDetails;

import java.util.List;
import java.util.Map;

/**
 * @serviceName HighDiscountPackageDetailsService.java
 * @author Sum1Dream
 * @version 1.0.0
 * @Description // 优惠券包详情服务
 * @createTime 3:11 下午 2021/11/25
 **/
public interface HighDiscountPackageDetailsService {

    /**
    * @Author Sum1Dream
    * @name getDiscountPackageDetailsList.java
    * @Description // 获取优惠券包详情卢列表
    * @Date 3:35 下午 2021/11/25
    * @Param [java.util.Map<java.lang.String,java.lang.Object>]
    * @return java.util.List<com.hai.entity.HighDiscountPackageDetails>
    */
    List<HighDiscountPackageDetails> getDiscountPackageDetailsList(Map<String , Object> map);

    /**
    * @Author Sum1Dream
    * @name findDetailsById.java
    * @Description // 获取详情
    * @Date 3:36 下午 2021/11/25
    * @Param [java.lang.Integer]
    * @return com.hai.entity.HighDiscountPackageDetails
    */
    HighDiscountPackageDetails findDetailsById(Integer id);

    /**
     * @Author Sum1Dream
     * @name insertDiscountPackageDetails.java
     * @Description // 新增优惠券包详情信息
     * @Date 12:07 下午 2021/11/25
     * @Param [com.hai.entity.HighDiscountPackage]
     * @return void
     */
    void insertDiscountPackageDetails(HighDiscountPackageDetails highDiscountPackageDetails);

    /**
     * @Author Sum1Dream
     * @name updateDiscountPackageDetails.java
     * @Description // 更新优惠券包详情信息
     * @Date 12:07 下午 2021/11/25
     * @Param [com.hai.entity.HighDiscountPackage]
     * @return void
     */
    void updateDiscountPackageDetails(HighDiscountPackageDetails highDiscountPackageDetails);

}
